Index: LMDZ6/branches/Portage_acc/libf/phylmd/phys_output_write_mod.F90
===================================================================
--- LMDZ6/branches/Portage_acc/libf/phylmd/phys_output_write_mod.F90	(revision 4445)
+++ LMDZ6/branches/Portage_acc/libf/phylmd/phys_output_write_mod.F90	(revision 4446)
@@ -25,5 +25,5 @@
 
     USE dimphy, ONLY: klon, klev, klevp1
-    USE infotrac_phy, ONLY: nbtr, nqtot, nqo, type_trac, tracers, niso, ntraciso
+    USE infotrac_phy, ONLY: nbtr, nqtot, nqo, type_trac, tracers, niso, ntiso
     USE strings_mod,  ONLY: maxlen
     USE mod_phys_lmdz_para, ONLY: is_north_pole_phy,is_south_pole_phy
@@ -271,5 +271,5 @@
         xtrain_con, xtsnow_con, xtrain_fall, xtsnow_fall, &
 #endif
-         dt_ns, delta_sst
+         dt_ns, delta_sst, dter, dser
 
     USE phys_local_var_mod, ONLY: zxfluxlat, slp, ptstar, pt0, zxtsol, zt2m, &
@@ -390,5 +390,5 @@
          alt_tropo, &
 !Ionela
-         ok_4xCO2atm, dter, dser, tkt, tks, taur, sss
+         ok_4xCO2atm, tkt, tks, taur, sss
 
     USE ocean_slab_mod, ONLY: nslay, tslab, slab_bilg, tice, seaice, &
@@ -481,4 +481,5 @@
 #ifdef CPP_StratAer 
     LOGICAL, PARAMETER :: debug_strataer=.FALSE.
+    CHARACTER(LEN=maxlen) :: unt
 #endif
     REAL,DIMENSION(klon,klev) :: z, dz
@@ -942,5 +943,5 @@
        CALL histwrite_phy(o_SWupTOAclr, zx_tmp_fi2d)
 
-       IF ((type_trac/='inca') .OR. (config_inca=='aeNP')) THEN 
+       IF (type_trac/='inca' .OR. config_inca=='aeNP') THEN 
           IF (vars_defined) THEN
              zx_tmp_fi2d(:) = swupc0(:,klevp1)*swradcorr(:)
@@ -1014,5 +1015,5 @@
        CALL histwrite_phy(o_SWupSFCclr, zx_tmp_fi2d)
 
-       IF ((type_trac/='inca') .OR. (config_inca=='aeNP')) THEN 
+       IF (type_trac/='inca' .OR. config_inca=='aeNP') THEN 
           IF (vars_defined) THEN
              zx_tmp_fi2d(:) = swupc0(:,1)*swradcorr(:)
@@ -1031,5 +1032,5 @@
        CALL histwrite_phy(o_SWdnSFCclr, zx_tmp_fi2d)
 
-       IF ((type_trac/='inca') .OR. (config_inca=='aeNP')) THEN 
+       IF (type_trac/='inca' .OR. config_inca=='aeNP') THEN 
           IF (vars_defined) THEN
              zx_tmp_fi2d(:) = swdnc0(:,1)*swradcorr(:)
@@ -1053,5 +1054,5 @@
        CALL histwrite_phy(o_LWdnSFCclr, sollwdownclr)
 
-       IF ((type_trac/='inca') .OR. (config_inca=='aeNP')) THEN 
+       IF (type_trac/='inca' .OR. config_inca=='aeNP') THEN 
           IF (vars_defined) THEN
              zx_tmp_fi2d(:) = lwupc0(:,klevp1)
@@ -1060,5 +1061,5 @@
        ENDIF
 
-       IF ((type_trac/='inca') .OR. (config_inca=='aeNP')) THEN 
+       IF (type_trac/='inca' .OR. config_inca=='aeNP') THEN 
           IF (vars_defined) THEN
              zx_tmp_fi2d(:) = -1.*lwdnc0(:,1)
@@ -1569,5 +1570,5 @@
 !This is warranted by treating INCA aerosols as offline aerosols
        IF (flag_aerosol.GT.0) THEN
-          IF ((type_trac/='inca') .OR. (config_inca=='aeNP')) THEN 
+          IF (type_trac/='inca' .OR. config_inca=='aeNP') THEN 
 
              CALL histwrite_phy(o_od443aer, od443aer)
@@ -1692,5 +1693,5 @@
           CALL histwrite_phy(o_solswad0, zx_tmp_fi2d)
           
-          IF ((type_trac/='inca') .OR. (config_inca=='aeNP')) THEN 
+          IF (type_trac/='inca' .OR. config_inca=='aeNP') THEN 
 
              CALL histwrite_phy(o_toplwad, toplwad_aero)
@@ -1769,5 +1770,5 @@
        ! Champs 3D:
        IF (ok_ade .OR. ok_aie) then
-          IF ((type_trac/='inca') .OR. (config_inca=='aeNP')) THEN 
+          IF (type_trac/='inca' .OR. config_inca=='aeNP') THEN 
              CALL histwrite_phy(o_ec550aer, ec550aer)
           ENDIF
@@ -2228,5 +2229,5 @@
        CALL histwrite_phy(o_rsucs, zx_tmp_fi3d1)
 
-       IF ((type_trac/='inca') .OR. (config_inca=='aeNP')) THEN 
+       IF (type_trac/='inca' .OR. config_inca=='aeNP') THEN 
           IF (vars_defined) THEN
              DO k=1, klevp1
@@ -2244,5 +2245,5 @@
        CALL histwrite_phy(o_rsdcs, zx_tmp_fi3d1)
 
-       IF ((type_trac/='inca') .OR. (config_inca=='aeNP')) THEN 
+       IF (type_trac/='inca' .OR. config_inca=='aeNP') THEN 
           IF (vars_defined) THEN
              DO k=1, klevp1
@@ -2489,5 +2490,64 @@
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        IF (iflag_phytrac == 1 ) then
-         IF (type_trac == 'lmdz' .OR. type_trac == 'coag') THEN
+!
+         IF (type_trac == 'co2i') THEN
+           itr = 0
+           DO iq = 1, nqtot
+             IF(.NOT.tracers(iq)%isInPhysics) CYCLE
+             itr = itr + 1
+!            write(*,*) 'phys_output_write_mod 2370: itr=',itr
+             !--3D fields
+             CALL histwrite_phy(o_trac(itr), tr_seri(:,:,itr))
+             CALL histwrite_phy(o_dtr_vdf(itr),d_tr_cl(:,:,itr))
+             CALL histwrite_phy(o_dtr_the(itr),d_tr_th(:,:,itr))
+             CALL histwrite_phy(o_dtr_con(itr),d_tr_cv(:,:,itr))
+             !--2D fields
+             !--CO2 burden
+             zx_tmp_fi2d=0.
+             IF (vars_defined) THEN
+                DO k=1,klev
+                   zx_tmp_fi2d(:)=zx_tmp_fi2d(:)+zmasse(:,k)*tr_seri(:,k,itr)
+                ENDDO
+             ENDIF
+             CALL histwrite_phy(o_trac_cum(itr), zx_tmp_fi2d)
+           ENDDO !--iq
+           !--CO2 net fluxes
+           CALL histwrite_phy(o_flx_co2_land,  fco2_land)
+           CALL histwrite_phy(o_flx_co2_ocean, fco2_ocean)
+           CALL histwrite_phy(o_flx_co2_ocean_cor, fco2_ocean_cor)
+           CALL histwrite_phy(o_flx_co2_land_cor, fco2_land_cor)
+           CALL histwrite_phy(o_flx_co2_ff,    fco2_ff)
+           CALL histwrite_phy(o_flx_co2_bb,    fco2_bb)
+
+         ELSE IF (type_trac == 'inco') THEN
+           itr = 0
+           DO iq = 1, nqtot
+             IF(.NOT.tracers(iq)%isInPhysics) CYCLE
+             itr = itr+1
+             IF(tracers(iq)%component /= 'co2i') CYCLE
+             !--3D fields
+             CALL histwrite_phy(o_trac   (itr),tr_seri(:,:,itr))
+             CALL histwrite_phy(o_dtr_vdf(itr),d_tr_cl(:,:,itr))
+             CALL histwrite_phy(o_dtr_the(itr),d_tr_th(:,:,itr))
+             CALL histwrite_phy(o_dtr_con(itr),d_tr_cv(:,:,itr))
+             !--2D fields
+             !--CO2 burden
+             zx_tmp_fi2d=0.
+             IF (vars_defined) THEN
+                DO k=1,klev
+                   zx_tmp_fi2d(:)=zx_tmp_fi2d(:)+zmasse(:,k)*tr_seri(:,k,itr)
+                ENDDO
+             ENDIF
+             CALL histwrite_phy(o_trac_cum(itr), zx_tmp_fi2d)
+           ENDDO !--iq
+           !--CO2 net fluxes
+           CALL histwrite_phy(o_flx_co2_land,  fco2_land)
+           CALL histwrite_phy(o_flx_co2_ocean, fco2_ocean)
+           CALL histwrite_phy(o_flx_co2_ocean_cor, fco2_ocean_cor)
+           CALL histwrite_phy(o_flx_co2_land_cor, fco2_land_cor)
+           CALL histwrite_phy(o_flx_co2_ff,    fco2_ff)
+           CALL histwrite_phy(o_flx_co2_bb,    fco2_bb)
+
+         ELSE IF (ANY(type_trac==['lmdz','coag'])) THEN
            itr = 0
            DO iq = 1, nqtot
@@ -2521,65 +2581,4 @@
            ENDDO !--iq
          ENDIF   !--type_trac
-!
-         IF (type_trac == 'co2i') THEN
-           itr = 0
-           DO iq = 1, nqtot
-             IF(.NOT.tracers(iq)%isInPhysics) CYCLE
-             itr = itr + 1
-!            write(*,*) 'phys_output_write_mod 2370: itr=',itr
-             !--3D fields
-             CALL histwrite_phy(o_trac(itr), tr_seri(:,:,itr))
-             CALL histwrite_phy(o_dtr_vdf(itr),d_tr_cl(:,:,itr))
-             CALL histwrite_phy(o_dtr_the(itr),d_tr_th(:,:,itr))
-             CALL histwrite_phy(o_dtr_con(itr),d_tr_cv(:,:,itr))
-             !--2D fields
-             !--CO2 burden
-             zx_tmp_fi2d=0.
-             IF (vars_defined) THEN
-                DO k=1,klev
-                   zx_tmp_fi2d(:)=zx_tmp_fi2d(:)+zmasse(:,k)*tr_seri(:,k,itr)
-                ENDDO
-             ENDIF
-             CALL histwrite_phy(o_trac_cum(itr), zx_tmp_fi2d)
-           ENDDO !--iq
-           !--CO2 net fluxes
-           CALL histwrite_phy(o_flx_co2_land,  fco2_land)
-           CALL histwrite_phy(o_flx_co2_ocean, fco2_ocean)
-           CALL histwrite_phy(o_flx_co2_ocean_cor, fco2_ocean_cor)
-           CALL histwrite_phy(o_flx_co2_land_cor, fco2_land_cor)
-           CALL histwrite_phy(o_flx_co2_ff,    fco2_ff)
-           CALL histwrite_phy(o_flx_co2_bb,    fco2_bb)
-         ENDIF !--type_trac co2i
-
-         IF (type_trac == 'inco') THEN
-           itr = 0
-           DO iq = 1, nqtot
-             IF(.NOT.tracers(iq)%isInPhysics) CYCLE
-             itr = itr+1
-             IF(tracers(iq)%component /= 'co2i') CYCLE
-             !--3D fields
-             CALL histwrite_phy(o_trac   (itr),tr_seri(:,:,itr))
-             CALL histwrite_phy(o_dtr_vdf(itr),d_tr_cl(:,:,itr))
-             CALL histwrite_phy(o_dtr_the(itr),d_tr_th(:,:,itr))
-             CALL histwrite_phy(o_dtr_con(itr),d_tr_cv(:,:,itr))
-             !--2D fields
-             !--CO2 burden
-             zx_tmp_fi2d=0.
-             IF (vars_defined) THEN
-                DO k=1,klev
-                   zx_tmp_fi2d(:)=zx_tmp_fi2d(:)+zmasse(:,k)*tr_seri(:,k,itr)
-                ENDDO
-             ENDIF
-             CALL histwrite_phy(o_trac_cum(itr), zx_tmp_fi2d)
-           ENDDO !--iq
-           !--CO2 net fluxes
-           CALL histwrite_phy(o_flx_co2_land,  fco2_land)
-           CALL histwrite_phy(o_flx_co2_ocean, fco2_ocean)
-           CALL histwrite_phy(o_flx_co2_ocean_cor, fco2_ocean_cor)
-           CALL histwrite_phy(o_flx_co2_land_cor, fco2_land_cor)
-           CALL histwrite_phy(o_flx_co2_ff,    fco2_ff)
-           CALL histwrite_phy(o_flx_co2_bb,    fco2_bb)
-         ENDIF !--type_trac inco
-
        ENDIF   !(iflag_phytrac==1)
 
@@ -2598,5 +2597,5 @@
 
 #ifdef ISO
-    do ixt=1,ntraciso
+    do ixt=1,ntiso
 !        write(*,*) 'ixt'
         IF (vars_defined) zx_tmp_fi2d(:) = xtrain_fall(ixt,:) + xtsnow_fall(ixt,:)
@@ -2652,5 +2651,5 @@
 
     !write(*,*) 'phys_output_write_mod 2531'
-    enddo !do ixt=1,ntraciso    
+    enddo
 #endif
 
Index: LMDZ6/branches/Portage_acc/libf/phylmd/phys_state_var_mod.F90
===================================================================
--- LMDZ6/branches/Portage_acc/libf/phylmd/phys_state_var_mod.F90	(revision 4445)
+++ LMDZ6/branches/Portage_acc/libf/phylmd/phys_state_var_mod.F90	(revision 4446)
@@ -491,5 +491,16 @@
       ! Ocean-air interface salinity minus bulk salinity, in ppt
       
-      !$OMP THREADPRIVATE(delta_sal, ds_ns, dt_ns, delta_sst)
+      REAL, ALLOCATABLE, SAVE:: dter(:) ! (klon)
+      ! Temperature variation in the diffusive microlayer, that is
+      ! ocean-air interface temperature minus subskin temperature. In K.
+
+      REAL, SAVE, ALLOCATABLE:: dser(:) ! (klon)
+      ! Salinity variation in the diffusive microlayer, that is
+      ! ocean-air interface salinity minus subskin salinity. In ppt.
+
+      real, SAVE, ALLOCATABLE:: dt_ds(:) ! (klon)
+      ! (tks / tkt) * dTer, in K
+
+      !$OMP THREADPRIVATE(delta_sal, ds_ns, dt_ns, delta_sst, dter, dser, dt_ds)
 
     CONTAINS
@@ -501,8 +512,9 @@
 USE infotrac_phy, ONLY : nbtr
 #ifdef ISO
-USE infotrac_phy, ONLY : ntraciso,niso
+USE infotrac_phy, ONLY : ntraciso=>ntiso,niso
 #endif
 USE indice_sol_mod
 use config_ocean_skin_m, only: activate_ocean_skin
+use surface_data, only: type_ocean
 IMPLICIT NONE
 
@@ -562,4 +574,8 @@
       ALLOCATE(coefh(klon,klev+1,nbsrf+1))
       ALLOCATE(coefm(klon,klev+1,nbsrf+1))
+      ! initialize cleanly coefh,coefm
+      ! (most of the time in the code these are assumed to be on klev levels)
+      coefh(:,:,:)=0
+      coefm(:,:,:)=0
       ALLOCATE(zmax0(klon), f0(klon))
       ALLOCATE(sig1(klon,klev), w01(klon,klev))
@@ -724,6 +740,11 @@
         du_gwd_front(:,:) = 0 !ym missing init   
       ENDIF
-      if (activate_ocean_skin >= 1) ALLOCATE(delta_sal(klon), ds_ns(klon), &
-           dt_ns(klon), delta_sst(klon))
+
+      if (activate_ocean_skin >= 1) then
+         ALLOCATE(delta_sal(klon), ds_ns(klon), dt_ns(klon), delta_sst(klon), &
+              dter(klon), dser(klon))
+         if (activate_ocean_skin == 2 .and. type_ocean == "couple") &
+              allocate(dt_ds(klon))
+      end if
 
     END SUBROUTINE phys_state_var_init
@@ -735,4 +756,5 @@
 USE indice_sol_mod
 use config_ocean_skin_m, only: activate_ocean_skin
+use surface_data, only: type_ocean
 IMPLICIT NONE
 include "clesphys.h"
@@ -863,6 +885,9 @@
       DEALLOCATE(ratqs_inter)
 
-      if (activate_ocean_skin >= 1) deALLOCATE(delta_sal, ds_ns, dt_ns, &
-           delta_sst)
+      if (activate_ocean_skin >= 1) then
+         deALLOCATE(delta_sal, ds_ns, dt_ns, delta_sst, dter, dser)
+         if (activate_ocean_skin == 2 .and. type_ocean == "couple") &
+              deALLOCATE(dt_ds)
+      end if
 
 #ifdef ISO    
